<?php /*
	PHP Directory Indexer
	---------------------

	Documentation
	-------------
	This is a small script which indexes the content of the directory where
	it is located (including the directories below).
	With the variable 'allow_parent' (see below) you can decide if you want
	to allow switching to the parent directory of the script. (by default
	it is turned off)	

	Copyright (c) 2004 Till Biedermann <tillbiedermann@yahoo.de>

	Changes
	----------
	
	2004-09-16
		- fixed security problem with manipulated URL's
	
	2004-08-27
		- made the script working with register_globals=Off
		- fixed the bug that files with the same like the script
		  were ignored
	
	2004-08-09
		- cleaned up the php and css code
		- valid xhtml 1.1 now
	
	License
	-------
	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
	USA.
*/ ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<meta name="author" content="Till Biedermann" />
	<meta name="description" content="directory listing" />
	<title>Directory listing powered by TBmnet.de</title>
	<style type="text/css">
		body	{	font-family:	Tahoma, sans-serif;	}
		img 	{ 	border:		0px;
				margin-top:	6px;		}
		h2	{	background-color:	#eeeeee;
				color:		#c0c0c0;
				letter-spacing:	.2em;
				padding:		.2em;
				text-align:	center;
				border-top:	solid #aaaaaa 1px;
				border-bottom:	solid #aaaaaa 1px;	}
		table	{	border-collapse:	collapse;
				margin-left:	auto;
				margin-right:	auto;
				margin-bottom:	10px;
				border:		solid #dddddd 1px;	}
		th	{	background-color:	#dddddd;		}
		td	{	padding:		2px 10px 2px 10px;
				background-color:	#ffffff;
				border:		solid #dddddd 1px;}
		a	{	text-decoration:	none;	
				font-weight:	bold;		}
		.black	{	color:		#000000;		}
	</style>
</head>
<body>
<?php 
	//  false - don't allow switching to the parent-directory of this script
	// true - allow simple switching to the parent-directory (via 'href')

	$allow_parent = "false";

	//configuration ends here---------------------------------------------------------------------------------------------------------------------------

//=======================================================================================
	$path=$_GET["path"];
	$SCRIPT_NAME=getenv("SCRIPT_NAME");
	//put directory content in arrays-----------------------------------------------------------------------------------------------------------------
	if (!isset($path)) { $path = "./"; }
	if (!file_exists($path)) { echo "<h2>File not found!</h2>"; exit; }
	if (strstr($path,"..")) { echo "<h2>invalid path!</h2>"; exit; }
	$base_dir = getcwd();
	chdir($path);
	$current_dir = getcwd();
	$directory = dir("./");	
	$directories_array = array();
	$files_array = array();
	while ($file = $directory->read()) {
		if (is_dir($file) AND $file != ".") 	{ $directories_array[] = $file; }
		if (is_file($file)) 			{ $files_array[] = $file; }
	}
	$directory->close();
	//sort and output the arrays-----------------------------------------------------------------------------------------------------------------------
	echo "<h2>Directory listing for <span class=\"black\">".basename($current_dir)."</span></h2>";
	echo "<table>";
	echo "<tr><th>Name</th><th>Size</th><th>Date</th></tr>";
	sort($directories_array);
	foreach($directories_array as $value) {
		if ($value=="..")	{ $new_path=strrev(substr(strstr(substr(strstr(strrev($path),"/"),1),"/"),1)); }
		else			{ $new_path=$path.$value; }
		if (($value != "..") OR ($base_dir != $current_dir)) {
			echo "<tr><td><a href=\"$SCRIPT_NAME?path=".urlencode($new_path."/")."\">$value</a><b>/</b></td><td></td><td>".gmdate("d M Y H:i",filemtime($value))."</td></tr>"; }
		elseif ($allow_parent == "true") {
			echo "<tr><td><a href=\"$value\">$value</a><b>/</b></td><td></td><td>".gmdate("d M Y H:i",filemtime($value))."</td></tr>"; }
	}
	sort($files_array);
	foreach($files_array as $value) {
		if($value != basename($SCRIPT_NAME) or $path!="./") {
			$filesize=filesize($value);
			if 	($filesize > 1073741823)	{ $filesize = sprintf("%.1f",($filesize/1073741824))." GB"; }
			elseif 	($filesize > 1048575) 	{ $filesize = sprintf("%.1f",($filesize/1048576))." MB"; }
			elseif 	($filesize > 1023) 	{ $filesize = sprintf("%.1f",($filesize/1024))." kB"; }
			else				{ $filesize = $filesize." byte"; }
			echo "<tr><td><a href=\"$path$value\">$value</a></td><td>$filesize</td><td>".gmdate("d M Y H:i",filemtime($value))."</td></tr>";
		}
	}
	echo "</table>";
	//footer-----------------------------------------------------------------------------------------------------------------------------------------------------
	echo "<h2><a href=\"http://validator.w3.org/check/referer\"><img src=\"http://www.w3.org/Icons/valid-xhtml11.png\" alt=\"Valid XHTML 1.1\" height=\"31\" width=\"88\" /></a>";
	echo "&nbsp;&nbsp;<a href=\"http://jigsaw.w3.org/css-validator/check/referer\"><img src=\"http://jigsaw.w3.org/css-validator/images/vcss.png\" alt=\"Valid CSS!\" height=\"31\" width=\"88\" /></a></h2>";
?>
</body>
</html>
